#!%%PMXPREFIX%%/bin/perl -w

use strict;
use warnings;
use Sophos::LogSearch::LogTail;
use Getopt::Long;
use IO::Handle;

my %opts;
my %extra;
my $continue       = 1;

GetOptions(\%opts, 'filename=s',
    'offset=i',
    'starts_with|s=s',
) or die usage();

foreach my $valid ( qw(offset starts_with) ) {
    next unless defined $opts{$valid};
    $extra{$valid} = $opts{$valid}; 
}

my $tailer = Sophos::LogSearch::LogTail->new( filename => $opts{filename},%extra);

$0 = "pmx-logsearch-index: tailing $opts{filename}";

my $fl = IO::Handle->new();

die "Can't open STDOUT for output" unless $fl->fdopen(fileno(STDOUT),"w");

$SIG{PIPE} = sub { $continue = 0 };
while ($continue) {
    if (my $data = $tailer->read) {
        my $status = syswrite($fl, $data);
        last unless defined $status;

        my $dlen = length($data);
        while ($status < $dlen) {
            my $count = syswrite($fl, $data, $dlen, $status);
            last unless defined $count;
            $status += $count;
        }
        $fl->flush();
    }
    else {
        my $result = syswrite($fl, "# ping\n");
        if (defined $result) { # undef == an error
            $fl->flush();
            sleep 1;
        }
    }
}

exit 0;

sub usage {
    <<END_USAGE;
USAGE:

END_USAGE
}


# vim: ft=perl
